#!/bin/bash

# Load variables from external configuration file
. configuration.sh

mkdir -p $DEBOOTSTRAP_DIR

$DEBOOTSTRAP --include=$DEBOOTSTRAP_INCLUDE_PACKAGES --exclude=$DEBOOTSTRAP_EXCLUDE_PACKAGE squeeze $DEBOOTSTRAP_DIR http://ftp.fr.debian.org/debian

chroot $DEBOOTSTRAP_DIR apt-get -y --force-yes install ash 2>/dev/null
chroot $DEBOOTSTRAP_DIR apt-get -y --force-yes clean 2>/dev/null

echo "127.0.0.1       localhost" > $DEBOOTSTRAP_DIR/etc/hosts

echo "localhost" >  $DEBOOTSTRAP_DIR/etc/hostname

rm $DEBOOTSTRAP_DIR/etc/resolv.conf #because of network manager ...

cat >> $DEBOOTSTRAP_DIR/root/.bashrc <<EOF
export PATH=/bin:/sbin:/usr/bin:/usr/sbin:/usr/local/bin
export LC_ALL="C"
EOF

mkdir -p $DEBOOTSTRAP_DIR/root/.ssh
cat $SSH_DEPLOY_PUBLIC_KEY > $DEBOOTSTRAP_DIR/root/.ssh/authorized_keys
mkdir -p $DEBOOTSTRAP_DIR/etc/kadeploy3/keys
cp $SSH_DEPLOY_PRIVATE_KEY $DEBOOTSTRAP_DIR/etc/kadeploy3/keys/
chmod 400 $DEBOOTSTRAP_DIR/etc/kadeploy3/keys/*

cat > $DEBOOTSTRAP_DIR/etc/nsswitch.conf <<EOF
passwd:     files
group:      files

hosts:      files dns

ethers:     files
etmasks:    files
networks:   files
protocols:  files
rpc:        files
services:   files

netgroup:   nisplus

publickey:  nisplus

automount:  files
aliases:    files nisplus
EOF

#We add the deploy user with root rights
head -n 1 $DEBOOTSTRAP_DIR/etc/passwd |sed -e 's/root/deploy/1' -e 's/root/deploy/1'>> $DEBOOTSTRAP_DIR/etc/passwd
head -n 1 $DEBOOTSTRAP_DIR/etc/shadow |sed 's/root/deploy/' >> $DEBOOTSTRAP_DIR/etc/shadow
head -n 1 $DEBOOTSTRAP_DIR/etc/shadow- |sed 's/root/deploy/' >> $DEBOOTSTRAP_DIR/etc/shadow-

cp linuxrc-debian $DEBOOTSTRAP_DIR/linuxrc

cp mkdev $DEBOOTSTRAP_DIR/dev

cp $SCRIPTS_DIR/* $DEBOOTSTRAP_DIR/usr/local/bin

chmod +x $DEBOOTSTRAP_DIR/usr/local/bin/*

mkdir $DEBOOTSTRAP_DIR/mnt/dest
mkdir $DEBOOTSTRAP_DIR/rambin
mkdir $DEBOOTSTRAP_DIR/mnt/tmp

for d in `find $DEBOOTSTRAP_DIR/usr/share -mindepth 1 -maxdepth 1|grep -v perl`
do
    rm -rf $d
done

# delete useless files generated by apt to reduce the resulting size of the initrd
rm $DEBOOTSTRAP_DIR/var/cache/apt/*.bin
