--
-- New field in the table `environments`
--
ALTER TABLE `environments` ADD `arch` varchar(56) NOT NULL;
ALTER TABLE `environments` ADD `alias` varchar(255) NOT NULL default '';

-- Larger env name in log table
ALTER TABLE `log` MODIFY `env` varchar(255) NOT NULL;

-- add architectures to env based on name
UPDATE `environments` SET `arch` = "ppc64le"  WHERE `name` LIKE "%ppc64%";
UPDATE `environments` SET `arch` = "aarch64"  WHERE `name` LIKE "%arm64%";
UPDATE `environments` SET `arch` = "x86_64"  WHERE `arch` = "";

-- For public env, rename the env and put the old name as alias
-- eg: debian11-ppc64-min => debian11-min
UPDATE  `environments`  SET `alias` = `name` WHERE `visibility` = "public" AND name LIKE "%-x64-%";
UPDATE  `environments`  SET `alias` = `name` WHERE `visibility` = "public" AND name LIKE "%-ppc64-%";
UPDATE  `environments`  SET `alias` = `name` WHERE `visibility` = "public" AND name LIKE "%-arm64-%";

UPDATE  `environments`  SET `name` = REPLACE(`name`,'-x64','') WHERE `visibility` = "public" AND name LIKE "%-x64-%";
UPDATE  `environments`  SET `name` = REPLACE(`name`,'-ppc64','') WHERE `visibility` = "public" AND name LIKE "%-ppc64-%";
UPDATE  `environments`  SET `name` = REPLACE(`name`,'-arch64','') WHERE `visibility` = "public" AND name LIKE "%-arm64-%";

